unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls,shlobj,IniFiles,WideStrings;

Const
  IniName='gcs.INI';   //INI File name

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    Button2: TButton;
    StatusBar1: TStatusBar;
    Label1: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  lg_StartFolder:string;
  hThread:Thandle;//һ
  ThreadID:DWord;
  SearchFile: TStringList;
  InitDir,DestDir,FileExtName,TagStr:string;
  MyFile:TInifile;
  Filename:string;
  
implementation

{$R *.dfm}

//ѡĿ¼Ի
// http://blog.sina.com.cn/s/blog_57eea7a00100b7uh.html
function BrowseForFolderCallBack(Wnd:HWND;uMsg:UINT;
  lParam,lpData:LPARAM):Integer stdcall;
begin
  if uMsg=BFFM_INITIALIZED then
    SendMessage(Wnd,BFFM_SETSELECTION,1,Integer(@lg_StartFolder[1]));
  result:=0;
end;

function BrowseForFolder(const browseTitle:string;
  const initialFolder:string=''):string;
const
  BIF_NEWDIALOGSTYLE=$40;
var
  browse_info:TBrowseInfo;
  folder:array[0..MAX_PATH] of char;
  find_context:PItemIDList;
begin
  FillChar(browse_info,SizeOf(browse_info),#0);
  lg_StartFolder:=initialFolder;
  browse_info.pszDisplayName:=@folder[0];
  browse_info.lpszTitle:=PChar(browseTitle);
  browse_info.ulFlags:=BIF_RETURNONLYFSDIRS or BIF_NEWDIALOGSTYLE;
  if initialFolder<>'' then
    browse_info.lpfn:=BrowseForFolderCallBack;
  find_context:=SHBrowseForFolder(browse_info);
  if Assigned(find_context) then
  begin
    if SHGetPathFromIDList(find_context,folder) then
      result:=folder
    else
      result:='';
    GlobalFreePtr(find_context);
  end
  else
    result:='';
end;

//ָĿ¼ļ
procedure SearchInFile(dir:string);
var
  sr:TsearchRec;
  i:integer;
  CopyToStr:String;

  F:TFileStream;
  S:WideString;
  W:WORD;

begin
     {һ׶:ҳʼdirĿ¼µļ,dirֵedit1Textȷ· '\'β
      ô·}
      if FindFirst(dir+'\*.*',faanyfile,sr)=0 then
      repeat
        if (sr.name<>'.')and(sr.name<>'..')  {ųĿ¼ͱĿ¼ļ}
          then
            if ((filegetattr(dir+sr.name) and  fadirectory)=fadirectory) {Ŀ¼} then
                begin
                  if uppercase(dir+sr.name)<>uppercase(dir+'build') then {ųRoor\buildĿ¼}
                      searchinfile(dir+sr.name+'\');{ݹ}
                end
            else       //洦ļ
              if (pos(ExtractFileExt(sr.name),FileExtName)<>0)     {ļҪɨ}
                then
                  begin
                    //жļǷΪUnicode,жϷǲ鿴ļͷ

                    F:=TFileStream.Create(dir+sr.name,fmOpenRead or fmShareDenyNone);
                    F.Read(w,2);
                    if w=$FEFF then
                      begin
                        I:=F.Size;
                        SetLength(S,I div 2);
                        F.Read(S[1],I);
                        Delete(S,1,2);
                        SearchFile.Add(s);
                      end
                     else
                       begin
                         {ļݶȡ TStringList }
                         SearchFile.LoadFromFile(dir+sr.name);
                       end;
                     F.Free;

                    {ٶϵĿǣ״̬ϵʾ}
                    if random(10)<1 then    {ʮ֮һĸʾǰڴļ}
                      begin
                        Form1.StatusBar1.Panels.Items[0].Text:=dir+sr.name;
                       end;

                    for i := 0 to SearchFile.Count-1 do
                      begin
                        if pos(TagStr,SearchFile[i])<>0 then
                          begin
                            //Form1.Caption:=dir+sr.name;
                            CopyToStr:=DestDir+ExtractRelativePath(InitDir,dir);
                            ForceDirectories(CopyToStr);
                            //Form1.Memo1.lines.add(targetpath+sr.name+'  to  '+CopyToStr+sr.name);
                            if CopyFile(PChar(dir+sr.name),PChar(CopyToStr+sr.name),True) then
                               break
                            else
                              begin
                                //ShowMessage('Error in copy: ' + SysErrorMessage(GetLastError));
                                Form1.Memo1.lines.add('Error in copy: ' + SysErrorMessage(GetLastError));
                                Form1.Memo1.lines.add(dir+sr.name+'  to  '+CopyToStr+sr.name);
                              end;
                            break;
                         end;
                      end;
                 end;
         Application.ProcessMessages;
      until (findnext(sr)<>0);
      findclose(sr);

end;

procedure TForm1.Button1Click(Sender: TObject);
var opath,dpath,omsg:String;
begin
  dpath:='c:\';
  omsg:='ѡ·';
  opath:=BrowseForFolder(omsg,dpath);
  {ѡеĿ¼ƺ '\' 磺c:\abs Ҳûб 'c:\'}
  if opath<>'' then
    begin
      if IsPathDelimiter(opath,length(opath)) then
        begin
          Memo1.Lines.Add('Please DONOT choose root dirctory!');
          Exit;
        end;
      Edit1.Text:=opath+'\';
    end
  else
    begin
      Memo1.Lines.Add('Please choose a directory');
      Exit;
    end;

end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if DirectoryExists(Edit1.Text)=False then
     begin
       Memo1.Lines.Add('"'+Edit1.Text+'" DOESNOT Exist');
       exit;
     end;
     
  Button2.Enabled:=False;
  {ļ׺}
  FileExtName:=Edit2.Text;
  {עͱ}
  TagStr:=Edit3.Text;
  {ʼĿ¼ע⣬ʼĿ¼β '\'}
  if IsPathDelimiter(Edit1.Text,Length(Edit1.Text))=False then Edit1.Text:=Edit1.Text+'\';
  InitDir:=Edit1.Text;
  {ʼĿ¼һĿ¼ 'labz\'}
  DestDir:=ExtractFileDir(ExtractFileDir(Edit1.Text))+'\labz\';
  searchinfile(InitDir);
  Form1.Memo1.Lines.Add('Found files have been saved to '+DestDir);
  Form1.Memo1.Lines.Add('...........Done');
  Form1.StatusBar1.Panels.Items[0].Text:='';
  Button2.Enabled:=True;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  X,Y,Width,Height:integer;
begin
  Randomize;
  SearchFile:= TStringList.Create;

  FileName:=ExtractFilePath(paramstr(0))+IniName;
  if FileExists(FileName)=FALSE then       //INI File doesnot exist
     begin
       X:=0; Y:=0; Width:=511; Height:=280;  //Default
       Edit3.Text:='Tag_SC';
       Edit2.Text:='.c;.h;.bat;.xml;.txt;.asl;.inf;.dsc;.fdf;.bat;.asm;.uni;.vfi;.vfr';
     end
  else
     begin
        MyFile:=TInifile.Create(Filename);
        X:=MyFile.ReadInteger('Form','PostionX',0);  //X start
        Y:=MyFile.ReadInteger('Form','PostionY',0);  //y start
        Width:=MyFile.ReadInteger('Form','Width',511);
        Height:=MyFile.ReadInteger('Form','Height',280);
        Edit3.Text:=MyFile.ReadString('Application','Tag','Tag_SC');
        Edit2.Text:=MyFile.ReadString('Application','FileExt','.c;.h;.bat;.xml;.txt;.asl;.inf;.dsc;.fdf;.bat;.asm;.uni;.vfi;.vfr');
        MyFile.Destroy;
     end;
  MoveWindow(Form1.Handle, X, Y, Width, Height, True);
end;

procedure TForm1.FormDestroy(Sender: TObject);
var
  WinRect:TRect;
begin
  SearchFile.Free;
  GetWindowRect(Form1.Handle,WinRect);
  MyFile:=TInifile.Create(Filename);
  MyFile.WriteInteger('Form','PostionX',WinRect.Left);
  MyFile.writeinteger('Form','PostionY',WinRect.Top);
  MyFile.writeinteger('Form','Width',WinRect.Right-WinRect.Left);
  MyFile.writeinteger('Form','Height',WinRect.Bottom-WinRect.Top);
  MyFile.WriteString('Application','Tag',Edit3.Text);
  MyFile.WriteString('Application','FileExt',Edit2.Text);
  MyFile.Destroy;
end;

end.
